<?php

namespace Drupal\content_snapshot\Configuration;

/**
 * Interface for ConfigInterface.
 */
interface ConfigInterface {

  /**
   * Get snapshot path.
   *
   * @return string
   *   Snapshot path.
   */
  public function getSnapshotPath(): string;

  /**
   * Function to override snapshot path.
   *
   * @param string|null $snapshotPath
   *   Snapshot path.
   */
  public function overrideSnapshotPath(?string $snapshotPath);

  /**
   * Function to get strict.
   *
   * // phpcs:ignore
   * @return int
   */
  public function getStrict(): int;

  /**
   * Function to get snapshot stream.
   *
   * // phpcs:ignore
   * @return array
   */
  public function getSnapshotStreams(): array;

}
