<?php

namespace Drupal\content_snapshot;

use Drupal\content_snapshot\Compiler\ContentSnapshotExtensionPass;
use Drupal\content_snapshot\Compiler\D9CompatibilityExtensionPass;
use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceProviderBase;

/**
 * Provides dynamic customizations for the container.
 */
class ContentSnapshotServiceProvider extends ServiceProviderBase {

  /**
   * {@inheritdoc}
   */
  public function register(ContainerBuilder $container) {
    $container->addCompilerPass(new ContentSnapshotExtensionPass());

    if (version_compare(\Drupal::VERSION, '10.0.0', '<')) {
      $container->addCompilerPass(new D9CompatibilityExtensionPass());
    }
  }

}
