<?php

namespace Drupal\content_snapshot\Encoder;

use Symfony\Component\Yaml\Dumper;
use Symfony\Component\Yaml\Parser;

/**
 * Class for Yaml Encoder.
 *
 * We are using custom yaml encoder and format
 * as long as Drupal doesn't have
 * one in core, after that happen,
 * this class and format will become deprecated.
 */
class YamlEncoder implements YamlEncoderInterface {

  /**
   * {@inheritdoc}
   *
   * @var \Symfony\Component\Yaml\Dumper
   */
  private $dumper;

  /**
   * {@inheritdoc}
   *
   * @var \Symfony\Component\Yaml\Parser
   */
  private $parser;

  /**
   * {@inheritdoc}
   */
  public function __construct() {
    $this->dumper = new Dumper(2);
    $this->parser = new Parser();
  }

  /**
   * {@inheritdoc}
   */
  public function encode(mixed $data, string $format, array $context = []): string {
    return $this->dumper->dump($data, PHP_INT_MAX);
  }

  /**
   * {@inheritdoc}
   */
  public function supportsEncoding(string $format): bool {
    return $format === static::FORMAT;
  }

  /**
   * {@inheritdoc}
   */
  public function decode(string $data, string $format, array $context = []): mixed {
    return $this->parser->parse($data);
  }

  /**
   * {@inheritdoc}
   */
  public function supportsDecoding(string $format): bool {
    return $format === static::FORMAT;
  }

}
