<?php

namespace Drupal\content_snapshot\Encoder;

use Symfony\Component\Yaml\Dumper;
use Symfony\Component\Yaml\Parser;

/**
 * This is an encoder declaration that is compatible with D9's dependencies.
 */
class YamlEncoderD9 implements YamlEncoderInterface {

  /**
   * Dumper.
   *
   * @var \Symfony\Component\Yaml\Dumper
   */
  private $dumper;

  /**
   * Parser.
   *
   * @var \Symfony\Component\Yaml\Parser
   */
  private $parser;

  /**
   * {@inheritdoc}
   */
  public function __construct() {
    $this->dumper = new Dumper(2);
    $this->parser = new Parser();
  }

  /**
   * {@inheritdoc}
   */
  public function encode($data, $format, array $context = []): string {
    return $this->dumper->dump($data, PHP_INT_MAX);
  }

  /**
   * {@inheritdoc}
   */
  public function supportsEncoding($format): bool {
    return $format === static::FORMAT;
  }

  /**
   * {@inheritdoc}
   */
  public function decode($data, $format, array $context = []) {
    return $this->parser->parse($data);
  }

  /**
   * {@inheritdoc}
   */
  public function supportsDecoding($format): bool {
    return $format === static::FORMAT;
  }

}
