<?php

namespace Drupal\content_snapshot\Logger;

use Psr\Log\LoggerInterface as BaseLogger;

/**
 * D9 compatible logger.
 */
class LoggerD9 implements LoggerInterface {

  /**
   * The Logger Interface.
   *
   * @var \Psr\Log\LoggerInterface
   */
  private $logger;

  /**
   * Implements setLogger().
   *
   * @param \Psr\Log\LoggerInterface $logger
   *   Logger Interface.
   */
  public function setLogger(BaseLogger $logger): void {
    $this->logger = $logger;
  }

  /**
   * Implements emergency().
   */
  public function emergency($message, array $context = []): void {
    $this->logger->emergency($message, $context);
  }

  /**
   * Implements alert().
   */
  public function alert($message, array $context = []): void {
    $this->logger->alert($message, $context);
  }

  /**
   * Implements critical().
   */
  public function critical($message, array $context = []): void {
    $this->logger->critical($message, $context);
  }

  /**
   * Implements error().
   */
  public function error($message, array $context = []): void {
    $this->logger->error($message, $context);
  }

  /**
   * Implements warning().
   */
  public function warning($message, array $context = []): void {
    $this->logger->warning($message, $context);
  }

  /**
   * Implements notice().
   */
  public function notice($message, array $context = []): void {
    $this->logger->notice($message, $context);
  }

  /**
   * Implements info().
   */
  public function info($message, array $context = []): void {
    $this->logger->info($message, $context);
  }

  /**
   * Implements debug().
   */
  public function debug($message, array $context = []): void {
    $this->logger->debug($message, $context);
  }

  /**
   * Implements log().
   */
  public function log($level, $message, array $context = []): void {
    $this->logger->log($level, $message, $context);
  }

}
