<?php

namespace Drupal\content_snapshot\Normalizer;

/**
 * Trait for Content Snapshot Normalizer Context.
 *
 * @package Drupal\content_snapshot\Normalizer
 */
trait ContentSnapshotNormalizerContextTrait {

  /**
   * Id of the content snapshot context.
   *
   * @var string
   */
  public static $CONTENT_SNAPSHOT_CONTEXT = 'content_snapshot_context'; // phpcs:ignore Drupal.NamingConventions.ValidVariableName.LowerCamelName,Drupal.Files.LineLength.TooLong -- the current naming indicates the constant nature of this variable. It should be changed into an actual constant when constants in traits will become available.

  /**
   * Validates the given context.
   *
   * @param array $context
   *   Context.
   */
  private function validateContext(array &$context) {
    $context += [
      self::$CONTENT_SNAPSHOT_CONTEXT => FALSE,
    ];

    if (!$context[self::$CONTENT_SNAPSHOT_CONTEXT]) {
      throw new \LogicException("This normalizer is supposed to be used only in the Content Snapshot context. Check your normalizers priorities.");
    }
  }

}
