<?php

namespace Drupal\content_snapshot\Normalizer\layout_builder_st;

use Drupal\content_snapshot\Encoder\YamlEncoderInterface;
use Drupal\content_snapshot\Normalizer\ContentSnapshotNormalizerContextTrait;
use Drupal\layout_builder_st\Plugin\DataType\LayoutTranslationData;
use Drupal\serialization\Normalizer\TypedDataNormalizer;

/**
 * Implements Class LayoutTranslationDataNormalizer.
 */
class LayoutTranslationDataNormalizer extends TypedDataNormalizer {

  use ContentSnapshotNormalizerContextTrait;

  /**
   * {@inheritdoc}
   */
  protected $format = YamlEncoderInterface::FORMAT;

  /**
   * {@inheritdoc}
   */
  protected $supportedInterfaceOrClass = LayoutTranslationData::class;

  /**
   * {@inheritdoc}
   */
  public function normalize($object, $format = NULL, array $context = []):// phpcs:ignore Drupal.Commenting.FunctionComment.TypeHintMissing,Drupal.Files.LineLength.TooLong
  array|\ArrayObject|bool|float|int|NULL|string {

    $this->validateContext($context);

    $normalized = parent::normalize($object, $format, $context);

    if (!empty($normalized['components'])) {
      foreach ($normalized['components'] as &$component) {
        // We cannot leave it here, because it can cause broken references on
        // translated pages after the import.
        unset($component['block_revision_id']);
      }
    }

    return $normalized;
  }

}
