<?php

namespace Drupal\content_snapshot\ReferenceRestorer;

use Drupal\content_snapshot\Snapshot\SnapshotItemInterface;

/**
 * Implementation of the chain of reference restorers.
 */
class ReferenceRestorerChain implements ReferenceRestorerInterface {

  /**
   * Reference Restorer.
   *
   * @var \Drupal\content_snapshot\ReferenceRestorer\ReferenceRestorerInterface[]
   */
  private $referenceRestorers = [];

  /**
   * Function to  add reference restorer.
   *
   * @param \Drupal\content_snapshot\ReferenceRestorer\ReferenceRestorerInterface $referenceRestorer
   *   Reference Restorer.
   */
  public function addReferenceRestorer(ReferenceRestorerInterface $referenceRestorer) {
    $this->referenceRestorers[] = $referenceRestorer;
  }

  /**
   * {@inheritDoc}
   */
  public function restoreReferences(SnapshotItemInterface $snapshotItem, &$object): bool {
    foreach ($this->referenceRestorers as $resolver) {
      if ($result = $resolver->restoreReferences($snapshotItem, $object)) {
        return $result;
      }
    }

    return FALSE;
  }

}
