<?php

namespace Drupal\content_snapshot\Snapshot;

/**
 * Interface for TranslatableSnapshotItemInterface.
 */
interface TranslatableSnapshotItemInterface extends SnapshotItemInterface {

  public const TRANSLATIONS_KEY = '_content_snapshot_translations';

  /**
   * Get content translation from the snapshot.
   *
   * @param string $langcode
   *   Lang code of the translation.
   *
   * @return array|null
   *   Translation snapshot array.
   */
  public function getTranslation(string $langcode): ?array;

  /**
   * Is entity translatable?
   *
   * @return bool
   *   Boolean indicating if content in the snapshot is translatable.
   */
  public function isTranslatable(): bool;

  /**
   * Returns normalized entity fields only.
   *
   * @return array
   *   Array of fields.
   */
  public function getNormalizedFields(): array;

}
