<?php

namespace Drupal\content_snapshot\SnapshotWriter;

/**
 * Interface describing a component persisting snapshots.
 */
interface SnapshotWriterInterface {

  /**
   * Purges snapshot.
   */
  public function purge(): void;

  /**
   * Store the given content.
   *
   * @param string $id
   *   Id.
   * @param array $content
   *   Content.
   * @param string $path
   *   Path.
   *
   * @return mixed
   *   Returns mixed.
   */
  public function writeContentItem(string $id, array $content, string $path);

  /**
   * Store the given stream.
   *
   * @param string $scheme
   *   Scheme.
   * @param string|null $pathExcludePattern
   *   Path exclude pattern.
   */
  public function writeStream(string $scheme, ?string $pathExcludePattern): void;

}
