<?php

namespace Drupal\content_snapshot\Utils;

/**
 * Interface for FileSystemUtilsInterface.
 */
interface FileSystemUtilsInterface {

  /**
   * Copies directory to a specified destination.
   *
   * @param string $source
   *   Source.
   * @param string $destination
   *   Destination.
   * @param string $excludePattern
   *   Exclude pattern identifies files that shouldn't be copied.
   */
  public function copyDirectory(string $source, string $destination, string $excludePattern = ''): void;

  /**
   * Purge a directory specified by URI.
   *
   * @param string $uri
   *   Uri.
   */
  public function purgeDirectory($uri): void;

  /**
   * Get array of subdirectories of a given path.
   *
   * @param string $path
   *   Path.
   *
   * @return array
   *   Returns.
   */
  public function getSubdirectories($path): array;

}
